#include "string.h"
#include "stdlib.h"

#include "SDL.h"
#include "SDL_ttf.h"

#include "BList.h"
#include "auxiliar.h"

#include "BWindow.h"
#include "BActiveWindow.h"
#include "BStringEdDlg.h"

#ifdef KITSCHY_DEBUG_MEMORY 
#include "debug_memorymanager.h"
#endif

BStringEdDlg::BStringEdDlg(int x,int y,int dx,int dy,char *q,char *es,int ml,char *forbiden,TTF_Font *font) : BActiveWindow(x,y,dx,dy,font)
{
	query=q;
	editing_string=es;
	maxlength=ml;
	forbiden_characters=forbiden;
} /* BStringEdDlg::BStringEdDlg */ 


BStringEdDlg::~BStringEdDlg()
{
} /* BStringEdDlg::~BStringEdDlg */ 


void BStringEdDlg::contens_size(int *dx,int *dy)
{
	*dx=old_dx;
	*dy=old_dy;
} /* BStringEdDlg::contens_size */ 


void BStringEdDlg::draw_contens(SDL_Surface *sfc,int stx,int sty,int dx,int dy)
{
	SDL_Rect r;

	SDL_FillRect(sfc,0,0x0000007f);

	r.x=1-stx;
	r.y=1-sty;
	r.w=dx-2;
	r.h=dy-2;
	SDL_FillRect(sfc,&r,0x000000ff);
	print_centered(query,font,255,255,255,sfc,sfc->w/2-stx,8-sty);

	r.x=10-stx;
	r.y=(dy-20)-sty;
	r.w=dx-20;
	r.h=12;
	SDL_FillRect(sfc,&r,0);

	print_left(editing_string,font,255,255,255,sfc,15-stx,(dy-18)-sty);
	print_left("_",font,128,128,255,sfc,15+get_text_width(editing_string,font)-stx,(dy-18)-sty);
} /* BStringEdDlg::draw_contens */ 


bool BStringEdDlg::event(SDL_Event *event)
{
	if (active_window!=this) return true;

	if (event->type==SDL_KEYDOWN) {
		/* Keyboard event */ 
		if (event->key.keysym.sym==SDLK_BACKSPACE) {
			if (editing_string[0]!=0) editing_string[strlen(editing_string)-1]=0;
		} else {
			if (event->key.keysym.sym==SDLK_RETURN) {
//				strlwr(editing_string);
				return false;
			} /* if */ 

			if (event->key.keysym.unicode < 0x80 && event->key.keysym.unicode > 0) {
				bool found=false;

				if (forbiden_characters!=0) {
					int i;

					for(i=0;forbiden_characters[i]!=0 && !found;i++) if (event->key.keysym.unicode==forbiden_characters[i]) found=true;					
				} /* if */ 

				if (!found) {
					editing_string[strlen(editing_string)+1]=0;
					editing_string[strlen(editing_string)]=(char)event->key.keysym.unicode;
				} /* if */ 
			} /* if */ 
		} /* if */ 

		editing_string[maxlength]=0;
		dirty=true;
    } /* if */ 

	return true;
} /* BStringEdDlg::Event */ 

