#include "string.h"
#include "stdlib.h"

#include "SDL.h"
#include "SDL_image.h"
#include "SDL_ttf.h"
#include "SDL_mixer.h"

#include "BList.h"
#include "auxiliar.h"
#include "MOG2_auxiliar.h"

#include "samples.h"
#include "animscript.h"
#include "conditionscript.h"
#include "actionscript.h"
#include "variables.h"
#include "mog2.h"
#include "object.h"
#include "samples.h"
#include "interfaces.h"

#include "BWindow.h"
#include "BFileListWnd.h"
#include "BActiveWindow.h"
#include "BStringEdDlg.h"
#include "BIntegerEdDlg.h"
#include "BChoiceDlg.h"
#include "BVChoiceDlg.h"
#include "BFileDlg.h"
#include "BKeySelectionDlg.h"
#include "AnimScriptWnd.h"
#include "AnimEditorWnd.h"
#include "ActionScriptWnd.h"
#include "ActionEditorWnd.h"

#include "OPropertiesWnd.h"

#include "OVariableEditorWnd.h"
#include "BDrawingModeWnd.h"
#include "SampleSelectorDlg.h"

#include "editor.h"

#ifdef KITSCHY_DEBUG_MEMORY 
#include "debug_memorymanager.h"
#endif

OPropertiesWnd::OPropertiesWnd(int x,int y,int dx,int dy,EDITOR *e,TTF_Font *font) : BWindow(x,y,dx,dy,font)
{
	BButton *b;

	editor=e;

	b=new BButton(4,4,50,12,"CONS.",1);
	buttons.Add(b);

	b=new BButton(120,4,50,12,"CTRL.",10);
	buttons.Add(b);

	b=new BButton(4,20,60,12,"STATE",7);
	buttons.Add(b);

	b=new BButton(70,20,40,12,"SUB",8);
	buttons.Add(b);

	b=new BButton(120,20,70,12,"C.STATE",2);
	buttons.Add(b);

	b=new BButton(196,20,40,12,"SUB",3);
	buttons.Add(b);

	b=new BButton(4,36,100,12,"VARIABLES",4);
	buttons.Add(b);

	b=new BButton(120,36,100,12,"DRAWING MODE",9);
	buttons.Add(b);

	flag_active=new BButton(244,4,10,10,"",5);
	flag_pushable=new BButton(244,19,10,10,"",5);
	flag_multiroom=new BButton(244,34,10,10,"",5);
	flag_collision=new BButton(244,49,10,10,"",5);


	ch_stair_btn=new BButton(4,210,10,10,"",6);
	ch_stop_floor_btn=new BButton(20,290,10,10,"",6);
	ch_jump_btn=new BButton(4,310,10,10,"",6);
	ch_variable_jump_btn=new BButton(20,350,10,10,"",6);
	ch_controll_jump_btn=new BButton(20,360,10,10,"",6);

} /* OPropertiesWnd::OPropertiesWnd */ 


OPropertiesWnd::~OPropertiesWnd()
{
	delete flag_active;
	delete flag_pushable;
	delete flag_multiroom;
	delete flag_collision;

	delete ch_stair_btn;
	delete ch_stop_floor_btn;
	delete ch_jump_btn;
	delete ch_variable_jump_btn;
	delete ch_controll_jump_btn;
} /* OPropertiesWnd::~OPropertiesWnd */ 


bool OPropertiesWnd::cycle(int stx,int sty)
{
	int start_y=60;
	int i,j;
	char *tmp;

	BWindow::cycle(stx,sty);

	if (editor->ov_selected!=0) {
		switch(editor->ov_selected->control) {
		case CTRL_CHARACTER:
			{
				if (((mouse_button&SDL_BUTTON(1) &&
					 !(old_mouse_button&SDL_BUTTON(1))) ||
					 (mouse_button&SDL_BUTTON(3) &&
					 !(old_mouse_button&SDL_BUTTON(3)))) &&
					local_mouse_x>=old_stx && 
					local_mouse_y>=old_sty &&
					local_mouse_x<old_endx &&
					local_mouse_y<old_endy) {
					start_y=60;

					for(i=0;i<CPOS_NSTATES;i++) {
						if (i<13 ||
							(i>=13 && i<19 && editor->ov_selected->stair_states) ||
							(i>=19 && i<CPOS_NSTATES && editor->ov_selected->jump_states)) {

							if (local_mouse_y>=start_y && local_mouse_y<start_y+TTF_FontHeight(font) &&
								local_mouse_x>=15 && local_mouse_x<130) {
								/* Clicked on a CHARACTER state: */ 
								BVChoiceDlg *dlg;
								int res=0;

								dlg=new BVChoiceDlg(-1,-1,0,0,"Choose sample parameter:","no sample\nplay once\nrepeat synchronized\nplay once at exit\n"
																						 "play once (pan)\nrepeat synchronized (pan)\nplay once at exit(pan)\n",&res,font);
								dlg->Execute();
								delete dlg;

								if (res==1) {
									editor->ov_selected->state_sample[i]=0;
									editor->ov_selected->state_sample_command[i]=0;
									editor->ov_selected->state_sample_volume[i]=100;
								} /* if */ 
								if (res==2) {
									editor->ov_selected->state_sample_command[i]=1;
									editor->ov_selected->state_sample_volume[i]=100;
								} /* if */ 
								if (res==3) {
									editor->ov_selected->state_sample_command[i]=2;
									editor->ov_selected->state_sample_command_parameter[i]=4;
									editor->ov_selected->state_sample_volume[i]=100;
								} /* if */ 
								if (res==4) {
									editor->ov_selected->state_sample_command[i]=3;
									editor->ov_selected->state_sample_volume[i]=100;
								} /* if */ 

								if (res==5) {
									editor->ov_selected->state_sample_command[i]=4;
									editor->ov_selected->state_sample_volume[i]=100;
								} /* if */ 
								if (res==6) {
									editor->ov_selected->state_sample_command[i]=5;
									editor->ov_selected->state_sample_command_parameter[i]=4;
									editor->ov_selected->state_sample_volume[i]=100;
								} /* if */ 
								if (res==7) {
									editor->ov_selected->state_sample_command[i]=6;
									editor->ov_selected->state_sample_volume[i]=100;
								} /* if */ 

								set_dirty();
							} /* if */ 

							for(j=0;j<editor->ov_selected->nparts;j++) {
								if (local_mouse_y>=start_y && local_mouse_y<start_y+TTF_FontHeight(font) &&
									local_mouse_x>=140+j*100 && local_mouse_x<140+(j+1)*100) {
									/* Edit script: */ 
									BAnimEditorWnd *dlg=new BAnimEditorWnd(30,30,500,300,&editor->ov_selected->state_anim[j][i],editor->ov_selected,editor,font);

									dlg->Execute();
									delete dlg;

									set_dirty();
								} /* if */ 
							} /* for */ 
						} /* if */ 

						if (editor->ov_selected->state_sample_command[i]!=0) {
							char *cmd[]={"PLAY ONCE","REPEAT SYNCHRONIZED","PLAY ONCE AT EXIT",
										 "PLAY ONCE (pan)","REPEAT SYNCHRONIZED (pan)","PLAY ONCE AT EXIT (pan)"};
							char tmp[255];

							if (editor->ov_selected->state_sample[i]==0) sprintf(tmp,"%s: -",cmd[editor->ov_selected->state_sample_command[i]-1]);
																	else sprintf(tmp,"%s: %s",cmd[editor->ov_selected->state_sample_command[i]-1],editor->ov_selected->state_sample[i]->name);
							
							if (local_mouse_y>=start_y+10 && local_mouse_y<start_y+10+TTF_FontHeight(font) &&
								local_mouse_x>=24 && local_mouse_x<24+get_text_width(tmp,font)) {
								int x,y;
								SAMPLE *s=0;
								SampleSelectorDlg *dlg;

								new_window_coordinates(200,200,&x,&y);
								dlg=new SampleSelectorDlg(x,y,200,200,editor,&s,font);
								dlg->Execute();
								delete dlg;

								if (s!=0) editor->ov_selected->state_sample[i]=s;
								set_dirty();
							} /* if */ 

							if (local_mouse_y>=start_y+20 && local_mouse_y<start_y+20+TTF_FontHeight(font) &&
								local_mouse_x>=24 && local_mouse_x<24+get_text_width("Volume: 999",font)) {
								BIntegerEdDlg *dlg;
								int x,y;
				
								new_window_coordinates(140,60,&x,&y);
								dlg=new BIntegerEdDlg(x,y,140,60,"Enter Volume:",&editor->ov_selected->state_sample_volume[i],3,font);
								dlg->Execute();
								delete dlg;
								set_dirty();
							} /* if */ 

							if ((editor->ov_selected->state_sample_command[i]==2 ||
								 editor->ov_selected->state_sample_command[i]==5) &&
								local_mouse_y>=start_y+20 && local_mouse_y<start_y+20+TTF_FontHeight(font) &&
								local_mouse_x>=44+get_text_width("Volume: 999",font) && local_mouse_x<44+get_text_width("Volume: 999",font)+get_text_width("Step: 999",font)) {
								BIntegerEdDlg *dlg;
								int x,y;
				
								new_window_coordinates(140,60,&x,&y);
								dlg=new BIntegerEdDlg(x,y,140,60,"Enter Step:",&editor->ov_selected->state_sample_command_parameter[i],3,font);
								dlg->Execute();
								delete dlg;
								set_dirty();
							} /* if */ 
						} /* if */ 

						if (i==13) ch_stair_btn->m_y=start_y;
						if (i==19) ch_jump_btn->m_y=start_y;

						start_y+=10;
						if (editor->ov_selected->state_sample_command[i]!=0) start_y+=20;

						if (i==18) ch_stop_floor_btn->m_y=start_y+20;
						if (i==22) ch_variable_jump_btn->m_y=start_y;
						if (i==22) ch_controll_jump_btn->m_y=start_y+10;

						if (i==12 &&
							local_mouse_x>=44 && local_mouse_x<44+get_text_width("WALKING SPEED: 9999",font) &&
							local_mouse_y>=start_y && local_mouse_y<start_y+TTF_FontHeight(font)) {
							BIntegerEdDlg *dlg;
							int y,x;

							new_window_coordinates(140,60,&x,&y);
							dlg=new BIntegerEdDlg(x,y,140,60,"Enter walking speed:",&editor->ov_selected->walking_speed,4,font);
							dlg->Execute();
							delete dlg;
							set_dirty();
						} /* if */ 

						if (i==18 && 
							local_mouse_x>=44 && local_mouse_x<44+get_text_width("LADDER UP SPEED: 9999",font) &&
							local_mouse_y>=start_y && local_mouse_y<start_y+TTF_FontHeight(font)) {
							BIntegerEdDlg *dlg;
							int y,x;

							new_window_coordinates(140,60,&x,&y);
							dlg=new BIntegerEdDlg(x,y,140,60,"Enter up ladder speed:",&editor->ov_selected->ladder_up_speed,4,font);
							dlg->Execute();
							delete dlg;
							set_dirty();
						} /* if */ 

						if (i==18 && 
							local_mouse_x>=44 && local_mouse_x<44+get_text_width("LADDER DOWN SPEED: 9999",font) &&
							local_mouse_y>=start_y+10 && local_mouse_y<start_y+10+TTF_FontHeight(font)) {
							BIntegerEdDlg *dlg;
							int y,x;

							new_window_coordinates(160,60,&x,&y);
							dlg=new BIntegerEdDlg(x,y,160,60,"Enter down ladder speed:",&editor->ov_selected->ladder_down_speed,4,font);
							dlg->Execute();
							delete dlg;
							set_dirty();
						} /* if */ 


						if (i==22 &&
							local_mouse_x>=44 && local_mouse_x<44+get_text_width("JUMP CTNT: 9999",font) &&
							local_mouse_y>=start_y+20 && local_mouse_y<start_y+20+TTF_FontHeight(font)) {
							BIntegerEdDlg *dlg;
							int y,x;

							new_window_coordinates(140,60,&x,&y);
							dlg=new BIntegerEdDlg(x,y,140,60,"Enter jump ctnt:",&editor->ov_selected->jumping_ctnt,2,font);
							dlg->Execute();
							delete dlg;
							set_dirty();
						} /* if */ 

						if (i==22 &&
							local_mouse_x>=44 && local_mouse_x<44+get_text_width("JUMP KEY: XXXXXXX",font) &&
							local_mouse_y>=start_y+30 && local_mouse_y<start_y+30+TTF_FontHeight(font)) {
							BKeyDlg *dlg;
							int y,x;

							new_window_coordinates(250,100,&x,&y);
							dlg=new BKeyDlg(x,y,250,100,"Enter key:",&editor->ov_selected->jumping_key,font);
							dlg->Execute();
							delete dlg;

							set_dirty();
						} /* if */ 


						if (i==12) start_y+=20;
						if (i==18) start_y+=40;
						if (i==22) start_y+=50;

					} /* for */ 

					if (local_mouse_x>=ch_stair_btn->m_x && local_mouse_x<ch_stair_btn->m_x+ch_stair_btn->m_dx &&
						local_mouse_y>=ch_stair_btn->m_y && local_mouse_y<ch_stair_btn->m_y+ch_stair_btn->m_dy) {
						if (editor->ov_selected->stair_states) editor->ov_selected->stair_states=false;
														  else editor->ov_selected->stair_states=true;
						set_dirty();
					} /* if */ 

					if (local_mouse_x>=ch_stop_floor_btn->m_x && local_mouse_x<ch_stop_floor_btn->m_x+ch_stop_floor_btn->m_dx &&
						local_mouse_y>=ch_stop_floor_btn->m_y && local_mouse_y<ch_stop_floor_btn->m_y+ch_stop_floor_btn->m_dy) {
						if (editor->ov_selected->stop_at_each_floor) editor->ov_selected->stop_at_each_floor=false;
															    else editor->ov_selected->stop_at_each_floor=true;
						set_dirty();
					} /* if */ 

					if (local_mouse_x>=ch_jump_btn->m_x && local_mouse_x<ch_jump_btn->m_x+ch_jump_btn->m_dx &&
						local_mouse_y>=ch_jump_btn->m_y && local_mouse_y<ch_jump_btn->m_y+ch_jump_btn->m_dy) {
						if (editor->ov_selected->jump_states) editor->ov_selected->jump_states=false;
														 else editor->ov_selected->jump_states=true;
						set_dirty();
					} /* if */ 

					if (local_mouse_x>=ch_variable_jump_btn->m_x && local_mouse_x<ch_variable_jump_btn->m_x+ch_variable_jump_btn->m_dx &&
						local_mouse_y>=ch_variable_jump_btn->m_y && local_mouse_y<ch_variable_jump_btn->m_y+ch_variable_jump_btn->m_dy) {
						if (editor->ov_selected->variable_jumping) editor->ov_selected->variable_jumping=false;
															  else editor->ov_selected->variable_jumping=true;
						set_dirty();
					} /* if */ 

					if (local_mouse_x>=ch_controll_jump_btn->m_x && local_mouse_x<ch_controll_jump_btn->m_x+ch_variable_jump_btn->m_dx &&
						local_mouse_y>=ch_controll_jump_btn->m_y && local_mouse_y<ch_controll_jump_btn->m_y+ch_variable_jump_btn->m_dy) {
						if (editor->ov_selected->controllable_jump) editor->ov_selected->controllable_jump=false;
															   else editor->ov_selected->controllable_jump=true;
						set_dirty();
					} /* if */ 


				} /* if */ 				

			}
			break;

		case CTRL_STANDARD:
			/* OBJECT STATES: */ 
			if (((mouse_button&SDL_BUTTON(1) &&
				 !(old_mouse_button&SDL_BUTTON(1))) ||
				 (mouse_button&SDL_BUTTON(3) &&
				 !(old_mouse_button&SDL_BUTTON(3)))) &&
				local_mouse_x>=old_stx && 
				local_mouse_y>=old_sty &&
				local_mouse_x<old_endx &&
				local_mouse_y<old_endy) {

				for(i=0;i<editor->ov_selected->n_states;i++) {

					/* Click on "STATE i" */ 
					if (local_mouse_y>=start_y && local_mouse_y<start_y+TTF_FontHeight(font) &&
						local_mouse_x>=4 && local_mouse_x<4+get_text_width("STATE 00",font)) {
						BVChoiceDlg *dlg;
						int res=0;

						dlg=new BVChoiceDlg(-1,-1,0,0,"Choose action:","Duplicate\n",&res,font);
						dlg->Execute();
						delete dlg;							

						if (res==1) {
							int j,k;

							/* ADD A STATE: */ 
							AnimSCRIPT **tmp[MAX_PARTS];
							ActionSCRIPT **tmp2;
							char **tmp3;
				
							for(j=0;j<MAX_PARTS;j++) tmp[j]=new AnimSCRIPT *[editor->ov_selected->n_states+1];
							tmp2=new ActionSCRIPT *[editor->ov_selected->n_states+1];
							tmp3=new char *[editor->ov_selected->n_states+1];
							for(k=0;k<editor->ov_selected->n_states;k++) {
								for(j=0;j<MAX_PARTS;j++) tmp[j][k]=editor->ov_selected->g_state_anim[j][k];
								for(j=0;j<MAX_PARTS;j++) editor->ov_selected->g_state_anim[j][k]=0;
								tmp2[k]=editor->ov_selected->g_state_action[k];
								tmp3[k]=editor->ov_selected->g_state_description[k];
								editor->ov_selected->g_state_action[k]=0;
								editor->ov_selected->g_state_description[k]=0;
							} /* for */ 
							for(j=0;j<MAX_PARTS;j++) tmp[j][editor->ov_selected->n_states]=new AnimSCRIPT(*tmp[j][i]);
							tmp2[editor->ov_selected->n_states]=new ActionSCRIPT(*tmp2[i]);
							tmp3[editor->ov_selected->n_states]=new char[strlen(tmp3[i])+1];
							strcpy(tmp3[editor->ov_selected->n_states],tmp3[i]);
							editor->ov_selected->n_states++;
							for(j=0;j<MAX_PARTS;j++) delete []editor->ov_selected->g_state_anim[j];
							for(j=0;j<MAX_PARTS;j++) editor->ov_selected->g_state_anim[j]=tmp[j];
							delete []editor->ov_selected->g_state_action;
							delete []editor->ov_selected->g_state_description;
							editor->ov_selected->g_state_action=tmp2;
							editor->ov_selected->g_state_description=tmp3;
							set_dirty();
						} /* if */ 
					} /* if */ 

					if (local_mouse_y>=start_y && local_mouse_y<start_y+TTF_FontHeight(font) &&
						local_mouse_x>=64 && local_mouse_x<264) {
						char tmp[80];
						int x,y;
						BStringEdDlg *dlg;

						strcpy(tmp,editor->ov_selected->g_state_description[i]);
						new_window_coordinates(320,60,&x,&y);
						dlg=new BStringEdDlg(x,y,320,60,"Enter state description:",tmp,80,"",font);
						dlg->Execute();
						delete dlg;

						delete []editor->ov_selected->g_state_description[i];
						editor->ov_selected->g_state_description[i]=new char[strlen(tmp)+1];
						strcpy(editor->ov_selected->g_state_description[i],tmp);
						set_dirty();
					} /* if */ 
	
					start_y+=10;

					for(j=0;j<editor->ov_selected->nparts;j++) {
						if (local_mouse_y>=start_y && local_mouse_y<start_y+TTF_FontHeight(font) &&
							local_mouse_x>=140+j*100 && local_mouse_x<140+(j+1)*100) {
							/* Edit script: */ 
							BAnimEditorWnd *dlg=new BAnimEditorWnd(30,30,500,300,&editor->ov_selected->g_state_anim[j][i],editor->ov_selected,editor,font);

							dlg->Execute();
							delete dlg;
							set_dirty();
						} /* if */ 
					} /* for */ 
					start_y+=10;

					tmp=editor->ov_selected->g_state_action[i]->generate_string();
					if (local_mouse_y>=start_y && local_mouse_y<start_y+TTF_FontHeight(font) &&
						local_mouse_x>=140 && local_mouse_x<140+get_text_width(tmp,font)) {
						/* Edit script: */ 
						BActionEditorWnd *dlg=new BActionEditorWnd(30,30,640,480,&editor->ov_selected->g_state_action[i],0,0,editor,0,font);
						dlg->Execute();
						delete dlg;
						set_dirty();
					} /* if */ 
					delete []tmp;
					start_y+=10;
				} /* for */ 
			} /* if */ 

			start_y+=10;
			break;

		case CTRL_TEXT:
		case CTRL_GAMEWINDOW:
		case CTRL_MENU:
			/* TEXT/GAMEWINDOW STATES: */ 
			if (((mouse_button&SDL_BUTTON(1) &&
				 !(old_mouse_button&SDL_BUTTON(1))) ||
				 (mouse_button&SDL_BUTTON(3) &&
				 !(old_mouse_button&SDL_BUTTON(3)))) &&
				local_mouse_x>=old_stx && 
				local_mouse_y>=old_sty &&
				local_mouse_x<old_endx &&
				local_mouse_y<old_endy) {

				for(i=0;i<editor->ov_selected->n_states;i++) {

					/* Click on "STATE i" */ 
					if (local_mouse_y>=start_y && local_mouse_y<start_y+TTF_FontHeight(font) &&
						local_mouse_x>=4 && local_mouse_x<4+get_text_width("STATE 00",font)) {
						BVChoiceDlg *dlg;
						int res=0;

						dlg=new BVChoiceDlg(-1,-1,0,0,"Choose action:","Duplicate\n",&res,font);
						dlg->Execute();
						delete dlg;							

						if (res==1) {
							int j,k;

							/* ADD A STATE: */ 
							AnimSCRIPT **tmp[MAX_PARTS];
							ActionSCRIPT **tmp2;
							char **tmp3;
				
							for(j=0;j<MAX_PARTS;j++) tmp[j]=new AnimSCRIPT *[editor->ov_selected->n_states+1];
							tmp2=new ActionSCRIPT *[editor->ov_selected->n_states+1];
							tmp3=new char *[editor->ov_selected->n_states+1];
							for(k=0;k<editor->ov_selected->n_states;k++) {
								for(j=0;j<MAX_PARTS;j++) tmp[j][k]=editor->ov_selected->g_state_anim[j][k];
								for(j=0;j<MAX_PARTS;j++) editor->ov_selected->g_state_anim[j][k]=0;
								tmp2[k]=editor->ov_selected->g_state_action[k];
								tmp3[k]=editor->ov_selected->g_state_description[k];
								editor->ov_selected->g_state_action[k]=0;
								editor->ov_selected->g_state_description[k]=0;
							} /* for */ 
							for(j=0;j<MAX_PARTS;j++) tmp[j][editor->ov_selected->n_states]=new AnimSCRIPT(*tmp[j][i]);
							tmp2[editor->ov_selected->n_states]=new ActionSCRIPT(*tmp2[i]);
							tmp3[editor->ov_selected->n_states]=new char[strlen(tmp3[i])+1];
							strcpy(tmp3[editor->ov_selected->n_states],tmp3[i]);
							editor->ov_selected->n_states++;
							for(j=0;j<MAX_PARTS;j++) delete []editor->ov_selected->g_state_anim[j];
							for(j=0;j<MAX_PARTS;j++) editor->ov_selected->g_state_anim[j]=tmp[j];
							delete []editor->ov_selected->g_state_action;
							delete []editor->ov_selected->g_state_description;
							editor->ov_selected->g_state_action=tmp2;
							editor->ov_selected->g_state_description=tmp3;
							set_dirty();
						} /* if */ 
					} /* if */ 

					if (local_mouse_y>=start_y && local_mouse_y<start_y+TTF_FontHeight(font) &&
						local_mouse_x>=64 && local_mouse_x<264) {
						char tmp[80];
						int x,y;
						BStringEdDlg *dlg;

						strcpy(tmp,editor->ov_selected->g_state_description[i]);
						new_window_coordinates(320,60,&x,&y);
						dlg=new BStringEdDlg(x,y,320,60,"Enter state description:",tmp,80,"",font);
						dlg->Execute();
						delete dlg;

						delete []editor->ov_selected->g_state_description[i];
						editor->ov_selected->g_state_description[i]=new char[strlen(tmp)+1];
						strcpy(editor->ov_selected->g_state_description[i],tmp);
						set_dirty();
					} /* if */ 
					start_y+=10;

					tmp=editor->ov_selected->g_state_action[i]->generate_string();
					if (local_mouse_y>=start_y && local_mouse_y<start_y+TTF_FontHeight(font) &&
						local_mouse_x>=140 && local_mouse_x<140+get_text_width(tmp,font)) {
						/* Edit script: */ 
						BActionEditorWnd *dlg=new BActionEditorWnd(30,30,640,480,&editor->ov_selected->g_state_action[i],0,0,editor,0,font);
						dlg->Execute();
						delete dlg;
						set_dirty();
					} /* if */ 
					delete []tmp;
					start_y+=10;
				} /* for */ 
			} /* if */ 

			start_y+=10;
			break;
		} /* switch */ 

		/* SPECIAL STATES: */ 
		if (((mouse_button&SDL_BUTTON(1) &&
			 !(old_mouse_button&SDL_BUTTON(1))) ||
			 (mouse_button&SDL_BUTTON(3) &&
			 !(old_mouse_button&SDL_BUTTON(3)))) &&
			local_mouse_x>=old_stx && 
			local_mouse_y>=old_sty &&
			local_mouse_x<old_endx &&
			local_mouse_y<old_endy) {

			for(i=0;i<editor->ov_selected->n_s_states;i++) {

				/* Click on "STATE i" */ 
				if (local_mouse_y>=start_y && local_mouse_y<start_y+TTF_FontHeight(font) &&
					local_mouse_x>=4 && local_mouse_x<4+get_text_width("STATE 00",font)) {
					BVChoiceDlg *dlg;
					int res=0;

					dlg=new BVChoiceDlg(-1,-1,0,0,"Choose action:","Duplicate\nMove up\nMove down\n",&res,font);
					dlg->Execute();
					delete dlg;							

					if (res==1) {
						int j,k;

						/* ADD A STATE: */ 
						AnimSCRIPT **tmp[MAX_PARTS];
						ActionSCRIPT **tmp2;
						ConditionSCRIPT **tmp3;
						bool *tmp4;
						int *tmp5;
						char **tmp6;
			
						for(j=0;j<MAX_PARTS;j++) tmp[j]=new AnimSCRIPT *[editor->ov_selected->n_s_states+1];
						tmp2=new ActionSCRIPT *[editor->ov_selected->n_s_states+1];
						tmp3=new ConditionSCRIPT *[editor->ov_selected->n_s_states+1];
						tmp4=new bool[editor->ov_selected->n_s_states+1];
						tmp5=new int[editor->ov_selected->n_s_states+1];
						tmp6=new char *[editor->ov_selected->n_s_states+1];
						for(k=0;k<editor->ov_selected->n_s_states;k++) {
							for(j=0;j<MAX_PARTS;j++) tmp[j][k]=editor->ov_selected->g_s_state_anim[j][k];
							for(j=0;j<MAX_PARTS;j++) editor->ov_selected->g_s_state_anim[j][k]=0;
							tmp2[k]=editor->ov_selected->g_s_state_action[k];
							editor->ov_selected->g_s_state_action[k]=0;
							tmp3[k]=editor->ov_selected->g_s_state_condition[k];
							editor->ov_selected->g_s_state_condition[k]=0;
							tmp4[k]=editor->ov_selected->g_s_state_exclusiveness[k];
							tmp5[k]=editor->ov_selected->g_s_state_priority[k];
							tmp6[k]=editor->ov_selected->g_s_state_description[k];
							editor->ov_selected->g_s_state_description[k]=0;
						} /* for */ 
						for(j=0;j<MAX_PARTS;j++) tmp[j][editor->ov_selected->n_s_states]=new AnimSCRIPT(*tmp[j][i]);
						tmp2[editor->ov_selected->n_s_states]=new ActionSCRIPT(*tmp2[i]);
						tmp3[editor->ov_selected->n_s_states]=new ConditionSCRIPT(*tmp3[i]);
						tmp4[editor->ov_selected->n_s_states]=tmp4[i];
						tmp5[editor->ov_selected->n_s_states]=tmp5[i];
						tmp6[editor->ov_selected->n_s_states]=new char[strlen(tmp6[i])+1];
						strcpy(tmp6[editor->ov_selected->n_s_states],tmp6[i]);
						editor->ov_selected->n_s_states++;
						for(j=0;j<MAX_PARTS;j++) delete []editor->ov_selected->g_s_state_anim[j];
						for(j=0;j<MAX_PARTS;j++) editor->ov_selected->g_s_state_anim[j]=tmp[j];
						delete []editor->ov_selected->g_s_state_action;
						editor->ov_selected->g_s_state_action=tmp2;
						delete []editor->ov_selected->g_s_state_condition;
						editor->ov_selected->g_s_state_condition=tmp3;
						delete []editor->ov_selected->g_s_state_exclusiveness;
						editor->ov_selected->g_s_state_exclusiveness=tmp4;
						delete []editor->ov_selected->g_s_state_priority;
						editor->ov_selected->g_s_state_priority=tmp5;
						delete []editor->ov_selected->g_s_state_description;
						editor->ov_selected->g_s_state_description=tmp6;
						set_dirty();
					} /* if */ 

					if (res==2) {
						if (i>0) {
							AnimSCRIPT *tmp[MAX_PARTS];
							ActionSCRIPT *tmp2;
							ConditionSCRIPT *tmp3;
							bool tmp4;
							int tmp5;
							char *tmp6;

							for(j=0;j<MAX_PARTS;j++) tmp[j]=editor->ov_selected->g_s_state_anim[j][i];
							tmp2=editor->ov_selected->g_s_state_action[i];
							tmp3=editor->ov_selected->g_s_state_condition[i];
							tmp4=editor->ov_selected->g_s_state_exclusiveness[i];
							tmp5=editor->ov_selected->g_s_state_priority[i];
							tmp6=editor->ov_selected->g_s_state_description[i];

							for(j=0;j<MAX_PARTS;j++) editor->ov_selected->g_s_state_anim[j][i]=editor->ov_selected->g_s_state_anim[j][i-1];
							editor->ov_selected->g_s_state_action[i]=editor->ov_selected->g_s_state_action[i-1];
							editor->ov_selected->g_s_state_condition[i]=editor->ov_selected->g_s_state_condition[i-1];
							editor->ov_selected->g_s_state_exclusiveness[i]=editor->ov_selected->g_s_state_exclusiveness[i-1];
							editor->ov_selected->g_s_state_priority[i]=editor->ov_selected->g_s_state_priority[i-1];
							editor->ov_selected->g_s_state_description[i]=editor->ov_selected->g_s_state_description[i-1];

							for(j=0;j<MAX_PARTS;j++) editor->ov_selected->g_s_state_anim[j][i-1]=tmp[j];
							editor->ov_selected->g_s_state_action[i-1]=tmp2;
							editor->ov_selected->g_s_state_condition[i-1]=tmp3;
							editor->ov_selected->g_s_state_exclusiveness[i-1]=tmp4;	
							editor->ov_selected->g_s_state_priority[i-1]=tmp5;
							editor->ov_selected->g_s_state_description[i-1]=tmp6;
							set_dirty();
						} /* if */ 
					} /* if */ 

					if (res==3) {
						if (i<editor->ov_selected->n_s_states-1) {
							AnimSCRIPT *tmp[MAX_PARTS];
							ActionSCRIPT *tmp2;
							ConditionSCRIPT *tmp3;
							bool tmp4;
							int tmp5;
							char *tmp6;

							for(j=0;j<MAX_PARTS;j++) tmp[j]=editor->ov_selected->g_s_state_anim[j][i];
							tmp2=editor->ov_selected->g_s_state_action[i];
							tmp3=editor->ov_selected->g_s_state_condition[i];
							tmp4=editor->ov_selected->g_s_state_exclusiveness[i];
							tmp5=editor->ov_selected->g_s_state_priority[i];
							tmp6=editor->ov_selected->g_s_state_description[i];

							for(j=0;j<MAX_PARTS;j++) editor->ov_selected->g_s_state_anim[j][i]=editor->ov_selected->g_s_state_anim[j][i+1];
							editor->ov_selected->g_s_state_action[i]=editor->ov_selected->g_s_state_action[i+1];
							editor->ov_selected->g_s_state_condition[i]=editor->ov_selected->g_s_state_condition[i+1];
							editor->ov_selected->g_s_state_exclusiveness[i]=editor->ov_selected->g_s_state_exclusiveness[i+1];
							editor->ov_selected->g_s_state_priority[i]=editor->ov_selected->g_s_state_priority[i+1];
							editor->ov_selected->g_s_state_description[i]=editor->ov_selected->g_s_state_description[i+1];

							for(j=0;j<MAX_PARTS;j++) editor->ov_selected->g_s_state_anim[j][i+1]=tmp[j];
							editor->ov_selected->g_s_state_action[i+1]=tmp2;
							editor->ov_selected->g_s_state_condition[i+1]=tmp3;
							editor->ov_selected->g_s_state_exclusiveness[i+1]=tmp4;
							editor->ov_selected->g_s_state_priority[i+1]=tmp5;
							editor->ov_selected->g_s_state_description[i+1]=tmp6;
							set_dirty();
						} /* if */ 
					} /* if */ 
				} /* if */ 

				if (local_mouse_y>=start_y && local_mouse_y<start_y+TTF_FontHeight(font) &&
					local_mouse_x>=64 && local_mouse_x<264) {
					char tmp[80];
					int x,y;
					BStringEdDlg *dlg;

					strcpy(tmp,editor->ov_selected->g_s_state_description[i]);
					new_window_coordinates(320,60,&x,&y);
					dlg=new BStringEdDlg(x,y,320,60,"Enter state description:",tmp,80,"",font);
					dlg->Execute();
					delete dlg;

					delete []editor->ov_selected->g_s_state_description[i];
					editor->ov_selected->g_s_state_description[i]=new char[strlen(tmp)+1];
					strcpy(editor->ov_selected->g_s_state_description[i],tmp);
					set_dirty();
				} /* if */ 


				start_y+=10;

				tmp=editor->ov_selected->g_s_state_condition[i]->generate_string();
				if (local_mouse_y>=start_y && local_mouse_y<start_y+TTF_FontHeight(font) &&
					local_mouse_x>=140 && local_mouse_x<140+get_text_width(tmp,font)) {
					/* Edit script: */ 
					BActionEditorWnd *dlg=new BActionEditorWnd(30,30,500,300,0,&editor->ov_selected->g_s_state_condition[i],0,editor,0,font);
					dlg->Execute();
					delete dlg;
					set_dirty();
				} /* if */ 
				delete []tmp;
				start_y+=10;

				switch(editor->ov_selected->control) {
				case CTRL_STANDARD:
				case CTRL_CHARACTER:
					for(j=0;j<editor->ov_selected->nparts;j++) {
						if (local_mouse_y>=start_y && local_mouse_y<start_y+TTF_FontHeight(font) &&
							local_mouse_x>=140+j*100 && local_mouse_x<140+(j+1)*100) {
							/* Edit script: */ 
							BAnimEditorWnd *dlg=new BAnimEditorWnd(30,30,500,300,&editor->ov_selected->g_s_state_anim[j][i],editor->ov_selected,editor,font);

							dlg->Execute();
							delete dlg;
							set_dirty();
						} /* if */ 
					} /* for */ 
					start_y+=10;
					break;

				case CTRL_TEXT:
				case CTRL_GAMEWINDOW:
					break;
				} /* switch */ 

				tmp=editor->ov_selected->g_s_state_action[i]->generate_string();
				if (local_mouse_y>=start_y && local_mouse_y<start_y+TTF_FontHeight(font) &&
					local_mouse_x>=140 && local_mouse_x<140+get_text_width(tmp,font)) {
					/* Edit script: */ 
					BActionEditorWnd *dlg=new BActionEditorWnd(30,30,640,480,&editor->ov_selected->g_s_state_action[i],0,0,editor,0,font);
					dlg->Execute();
					delete dlg;
					set_dirty();
				} /* if */ 
				delete []tmp;
				start_y+=10;

				if (local_mouse_y>=start_y && local_mouse_y<start_y+TTF_FontHeight(font) &&
					local_mouse_x>=140 && local_mouse_x<140+get_text_width("YES",font)) {
					/* Change exclusiveness: */ 
					if (editor->ov_selected->g_s_state_exclusiveness[i]) {
						editor->ov_selected->g_s_state_exclusiveness[i]=false;
					} else {
						editor->ov_selected->g_s_state_exclusiveness[i]=true;
					} /* if */ 
					set_dirty();
				} /* if */ 

				if (local_mouse_y>=start_y && local_mouse_y<start_y+TTF_FontHeight(font) &&
					local_mouse_x>=200 && local_mouse_x<200+get_text_width("PRIORITY: YES",font)) {
					/* Change priority: */ 
					BIntegerEdDlg *dlg;
					int y,x;

					new_window_coordinates(140,60,&x,&y);
					dlg=new BIntegerEdDlg(x,y,140,60,"Enter priority ctnt:",&editor->ov_selected->g_s_state_priority[i],2,font);
					dlg->Execute();
					delete dlg;
					set_dirty();

					set_dirty();
				} /* if */ 

				start_y+=20;
			} /* for */ 
		} /* if */ 

		if (((mouse_button&SDL_BUTTON(1) &&
			 !(old_mouse_button&SDL_BUTTON(1))) ||
			 (mouse_button&SDL_BUTTON(3) &&
			 !(old_mouse_button&SDL_BUTTON(3)))) &&
			local_mouse_x>=old_stx && 
			local_mouse_y>=old_sty &&
			local_mouse_x<old_endx &&
			local_mouse_y<old_endy) {

			if (local_mouse_x>=flag_active->m_x && local_mouse_x<flag_active->m_x+flag_active->m_dx &&
				local_mouse_y>=flag_active->m_y && local_mouse_y<flag_active->m_y+flag_active->m_dy) {
				if (editor->ov_selected->active_flag) editor->ov_selected->active_flag=false;
												 else editor->ov_selected->active_flag=true;
				set_dirty();
			} /* if */ 
			if (local_mouse_x>=flag_pushable->m_x && local_mouse_x<flag_pushable->m_x+flag_pushable->m_dx &&
				local_mouse_y>=flag_pushable->m_y && local_mouse_y<flag_pushable->m_y+flag_pushable->m_dy) {
				if (editor->ov_selected->pushable_flag) editor->ov_selected->pushable_flag=false;
												   else editor->ov_selected->pushable_flag=true;
				set_dirty();
			} /* if */ 
			if (local_mouse_x>=flag_multiroom->m_x && local_mouse_x<flag_multiroom->m_x+flag_multiroom->m_dx &&
				local_mouse_y>=flag_multiroom->m_y && local_mouse_y<flag_multiroom->m_y+flag_multiroom->m_dy) {
				if (editor->ov_selected->multiroom_flag) editor->ov_selected->multiroom_flag=false;
													else editor->ov_selected->multiroom_flag=true;
				set_dirty();
			} /* if */ 
			if (local_mouse_x>=flag_collision->m_x && local_mouse_x<flag_collision->m_x+flag_collision->m_dx &&
				local_mouse_y>=flag_collision->m_y && local_mouse_y<flag_collision->m_y+flag_collision->m_dy) {
				if (editor->ov_selected->collision_flag) editor->ov_selected->collision_flag=false;
													else editor->ov_selected->collision_flag=true;
				set_dirty();
			} /* if */ 
		} /* if */ 

	} /* if */ 

	return true;
} /* OPropertiesWnd::cycle */ 


void OPropertiesWnd::contens_size(int *dx,int *dy)
{
	int max_x=0;
	int max_y=0;
	
	BWindow::contens_size(dx,dy);

	if (editor->ov_selected!=0) {
		int i;
		char *tmp;

		max_x=264+get_text_width("multiroom object",font);

		switch(editor->ov_selected->control) {
		case CTRL_STANDARD:
			if (max_y<60+editor->ov_selected->n_states*30+
				      10+editor->ov_selected->n_s_states*60) max_y=60+editor->ov_selected->n_states*30+
																   10+editor->ov_selected->n_s_states*60;
			break;
		case CTRL_CHARACTER:
			{			
				int start_y=60;
				for(i=0;i<CPOS_NSTATES;i++) {
					if (i<13 ||
							(i>=13 && i<19 && editor->ov_selected->stair_states) ||
							(i>=19 && i<CPOS_NSTATES && editor->ov_selected->jump_states)) {
						if (max_x<140+100) 
							max_x=140+100;
					} /* if */ 
					start_y+=10;
					if (editor->ov_selected->state_sample_command[i]!=0) start_y+=20;
					if (i==12) start_y+=20;
					if (i==18) start_y+=40;
					if (i==22) start_y+=50;
				} /* for */ 
				if (max_y<start_y+editor->ov_selected->n_s_states*60) max_y=start_y+editor->ov_selected->n_s_states*60;
			}
			break;
		case CTRL_TEXT:
		case CTRL_GAMEWINDOW:
		case CTRL_MENU:
			if (max_y<60+editor->ov_selected->n_states*20+
				      10+editor->ov_selected->n_s_states*50) max_y=60+editor->ov_selected->n_states*20+
																   10+editor->ov_selected->n_s_states*50;
			break;
		} /* switch */ 

		for(i=0;i<editor->ov_selected->n_states;i++) {
			if (max_x<140+get_text_width(editor->ov_selected->g_state_description[i],font)) 
				max_x=140+get_text_width(editor->ov_selected->g_state_description[i],font);
			if (max_x<140+100) 
				max_x=140+100;
			tmp=editor->ov_selected->g_state_action[i]->generate_string();
			if (max_x<140+get_text_width(tmp,font)) 
				max_x=140+get_text_width(tmp,font);
			delete []tmp;
		} /* for */ 

		if (editor->ov_selected->control==CTRL_CHARACTER) {
			for(i=0;i<editor->ov_selected->n_s_states;i++) {
				if (max_x<140+get_text_width(editor->ov_selected->g_s_state_description[i],font)) 
					max_x=140+get_text_width(editor->ov_selected->g_s_state_description[i],font);
				if (max_x<140+100) 
					max_x=140+100;
				tmp=editor->ov_selected->g_s_state_action[i]->generate_string();
				if (max_x<140+get_text_width(tmp,font)) 
					max_x=140+get_text_width(tmp,font);
				delete []tmp;
				tmp=editor->ov_selected->g_s_state_condition[i]->generate_string();
				if (max_x<140+get_text_width(tmp,font)) 
					max_x=140+get_text_width(tmp,font);
				delete []tmp;
			} /* for */ 
		} /* if */ 

	} /* if */ 

	if (max_x>*dx) *dx=max_x;
	if (max_y>*dy) *dy=max_y;
} /* OPropertiesWnd::contens_size */ 


void OPropertiesWnd::draw_contens(SDL_Surface *sfc,int stx,int sty,int dx,int dy)
{
	SDL_FillRect(sfc,0,0);

	if (editor->ov_selected!=0) {
		int i,j;
		int start_y=60;
		char *tmp,tmp2[80];

		BWindow::draw_contens(sfc,stx,sty,dx,dy);

		switch(editor->ov_selected->constitution) {
		case CONS_NONE:print_left("NONE",font,255,255,255,sfc,60-stx,6-sty);
					   break;
		case CONS_SOLID:print_left("SOLID",font,255,255,255,sfc,60-stx,6-sty);
					   break;
		case CONS_SOLID_SURFACE:print_left("SOLID_SFC",font,255,255,255,sfc,60-stx,6-sty);
					   break;
		case CONS_WEAPON:print_left("WEAPON",font,255,255,255,sfc,60-stx,6-sty);
					   break;
		case CONS_LADDER:print_left("LADDER",font,255,255,255,sfc,60-stx,6-sty);
					   break;
		case CONS_CHARACTER:print_left("CHARACTER",font,255,255,255,sfc,60-stx,6-sty);
					   break;
		case CONS_ITEM:print_left("ITEM",font,255,255,255,sfc,60-stx,6-sty);
					   break;
		} /* switch */ 

		switch(editor->ov_selected->control) {
		case CTRL_STANDARD:print_left("STANDARD",font,255,255,255,sfc,180-stx,6-sty);
						   break;
		case CTRL_TEXT:print_left("TEXT",font,255,255,255,sfc,180-stx,6-sty);
					   break;
		case CTRL_GAMEWINDOW:print_left("GWINDOW",font,255,255,255,sfc,180-stx,6-sty);
					   break;
		case CTRL_CHARACTER:print_left("CHARACTER",font,255,255,255,sfc,180-stx,6-sty);
					   break;
		case CTRL_MENU:print_left("MENU",font,255,255,255,sfc,180-stx,6-sty);
					   break;
		} /* switch */ 

		local_draw_button(sfc,flag_active,stx,sty,editor->ov_selected->active_flag);
		print_left("active object",font,255,255,255,sfc,264-stx,4-sty);
		local_draw_button(sfc,flag_pushable,stx,sty,editor->ov_selected->pushable_flag);
		print_left("pushable object",font,255,255,255,sfc,264-stx,19-sty);
		local_draw_button(sfc,flag_multiroom,stx,sty,editor->ov_selected->multiroom_flag);
		print_left("multiroom object",font,255,255,255,sfc,264-stx,34-sty);
		local_draw_button(sfc,flag_collision,stx,sty,editor->ov_selected->collision_flag);
		print_left("test collision",font,255,255,255,sfc,264-stx,49-sty);

		switch(editor->ov_selected->control) {
		case CTRL_CHARACTER:
			/* Character information: */ 
			start_y=60;
			for(i=0;i<CPOS_NSTATES;i++) {
				if (i<13 ||
						(i>=13 && i<19 && editor->ov_selected->stair_states) ||
						(i>=19 && i<CPOS_NSTATES && editor->ov_selected->jump_states)) {
					for(j=0;j<editor->ov_selected->nparts;j++) {
						/* Draw the box behind the anim: */ 
						{
							SDL_Rect r;

							r.x=(140-stx) + j*100;
							r.y=(start_y-sty) - 1;
							r.w=100;
							r.h=TTF_FontHeight(font)+2;
							if ((j&0x01)==0) SDL_FillRect(sfc,&r,0x00000020);
										else SDL_FillRect(sfc,&r,0x00000040);
						}
						tmp=editor->ov_selected->state_anim[j][i]->generate_string();
						if (strlen(tmp)>12) {
							tmp[11]='.';
							tmp[12]='.';
							tmp[13]='.';
							tmp[14]=0;
						} /* if */ 
						print_left(tmp,font,255,255,255,sfc,150+j*100-stx,start_y-sty);
						delete []tmp;
					} /* for */ 
				} /* if */ 

				if (i==0) print_left("00 Stand right:",font,255,255,255,sfc,4-stx,start_y-sty);
				if (i==1) print_left("01 Stand left:",font,255,255,255,sfc,4-stx,start_y-sty);
				if (i==2) print_left("02 Pause:",font,255,255,255,sfc,4-stx,start_y-sty);
				if (i==3) print_left("03 Walking right:",font,255,255,255,sfc,4-stx,start_y-sty);
				if (i==4) print_left("04 Walking left:",font,255,255,255,sfc,4-stx,start_y-sty);
				if (i==5) print_left("05 Falling right:",font,255,255,255,sfc,4-stx,start_y-sty);
				if (i==6) print_left("06 Falling left:",font,255,255,255,sfc,4-stx,start_y-sty);
				if (i==7) print_left("07 Landing right:",font,255,255,255,sfc,4-stx,start_y-sty);
				if (i==8) print_left("08 Landing left:",font,255,255,255,sfc,4-stx,start_y-sty);
				if (i==9) print_left("09 recover hit right:",font,255,255,255,sfc,4-stx,start_y-sty);
				if (i==10) print_left("10 recover hit left:",font,255,255,255,sfc,4-stx,start_y-sty);
				if (i==11) print_left("11 Dead right:",font,255,255,255,sfc,4-stx,start_y-sty);
				if (i==12) print_left("12 Dead left:",font,255,255,255,sfc,4-stx,start_y-sty);
				if (i==13) print_left("13 Up stairs:",font,255,255,255,sfc,24-stx,start_y-sty);
				if (i==14) print_left("14 Down stairs:",font,255,255,255,sfc,24-stx,start_y-sty);
				if (i==15) print_left("15 Quiet Up st.:",font,255,255,255,sfc,24-stx,start_y-sty);
				if (i==16) print_left("16 Quiet Down st.:",font,255,255,255,sfc,24-stx,start_y-sty);
				if (i==17) print_left("17 Quiet Right st.:",font,255,255,255,sfc,24-stx,start_y-sty);
				if (i==18) print_left("18 Quiet Left st.:",font,255,255,255,sfc,24-stx,start_y-sty);
				if (i==19) print_left("19 Jump right:",font,255,255,255,sfc,24-stx,start_y-sty);
				if (i==20) print_left("20 Jump left:",font,255,255,255,sfc,24-stx,start_y-sty);
				if (i==21) print_left("21 Jump fall right:",font,255,255,255,sfc,24-stx,start_y-sty);
				if (i==22) print_left("22 Jump fall left:",font,255,255,255,sfc,24-stx,start_y-sty);

				if (editor->ov_selected->state_sample_command[i]!=0) {
					char *cmd[]={"PLAY ONCE","REPEAT SYNCHRONIZED","PLAY ONCE AT EXIT",
								 "PLAY ONCE (pan)","REPEAT SYNCHRONIZED (pan)","PLAY ONCE AT EXIT (pan)"};
					char tmp[255];

					if (editor->ov_selected->state_sample[i]==0) sprintf(tmp,"%s: -",cmd[editor->ov_selected->state_sample_command[i]-1]);
															else sprintf(tmp,"%s: %s",cmd[editor->ov_selected->state_sample_command[i]-1],editor->ov_selected->state_sample[i]->name);
					print_left(tmp,font,128,128,255,sfc,24-stx,start_y+10-sty);
					sprintf(tmp,"Volume: %i",editor->ov_selected->state_sample_volume[i]);
					print_left(tmp,font,128,128,255,sfc,24-stx,start_y+20-sty);

					if (editor->ov_selected->state_sample_command[i]==2 ||
						editor->ov_selected->state_sample_command[i]==5) {
						sprintf(tmp,"Step: %i",editor->ov_selected->state_sample_command_parameter[i]);
						print_left(tmp,font,128,128,255,sfc,44+get_text_width("Volume: 999",font)-stx,start_y+20-sty);
					} /* if */ 

				} /* if */ 

				if (i==13) ch_stair_btn->m_y=start_y;
				if (i==19) ch_jump_btn->m_y=start_y;

				start_y+=10;
				if (editor->ov_selected->state_sample_command[i]!=0) start_y+=20;

				if (i==12) {
					sprintf(tmp2,"WALKING SPEED: %i",editor->ov_selected->walking_speed);
					print_left(tmp2,font,255,255,255,sfc,44-stx,start_y-sty);
				} /* if */ 
				if (i==18) {
					sprintf(tmp2,"LADDER UP SPEED: %i",editor->ov_selected->ladder_up_speed);
					print_left(tmp2,font,255,255,255,sfc,44-stx,start_y-sty);
					sprintf(tmp2,"LADDER DOWN SPEED: %i",editor->ov_selected->ladder_down_speed);
					print_left(tmp2,font,255,255,255,sfc,44-stx,start_y+10-sty);
					sprintf(tmp2,"Stop at each floor");
					print_left(tmp2,font,255,255,255,sfc,44-stx,start_y+20-sty);
				} /* if */ 
				if (i==22) {
					if (editor->ov_selected->variable_jumping) print_left("Variable jump",font,255,255,255,sfc,44-stx,start_y-sty);
														  else print_left("Fixed jump",font,255,255,255,sfc,44-stx,start_y-sty);
					if (editor->ov_selected->controllable_jump) print_left("Controllable",font,255,255,255,sfc,44-stx,start_y+10-sty);
														   else print_left("Non Controllable",font,255,255,255,sfc,44-stx,start_y+10-sty);

					sprintf(tmp2,"JUMP CTNT: %i",editor->ov_selected->jumping_ctnt);
					print_left(tmp2,font,255,255,255,sfc,44-stx,start_y+20-sty);
					tmp2[0]=0;
					sprintf(tmp2,"JUMP KEY: %s",input_key_name(editor->ov_selected->jumping_key));
					print_left(tmp2,font,255,255,255,sfc,44-stx,start_y+30-sty);
				} /* if */ 

				if (i==18) ch_stop_floor_btn->m_y=start_y+20;
				if (i==22) ch_variable_jump_btn->m_y=start_y;

				if (i==12) start_y+=20;
				if (i==18) start_y+=40;
				if (i==22) start_y+=50;
			} /* for */ 

			local_draw_button(sfc,ch_stair_btn,stx,sty,editor->ov_selected->stair_states);
			local_draw_button(sfc,ch_stop_floor_btn,stx,sty,editor->ov_selected->stop_at_each_floor);	
			local_draw_button(sfc,ch_jump_btn,stx,sty,editor->ov_selected->jump_states);
			local_draw_button(sfc,ch_variable_jump_btn,stx,sty,editor->ov_selected->variable_jumping);	
			local_draw_button(sfc,ch_controll_jump_btn,stx,sty,editor->ov_selected->controllable_jump);
		break;

		case CTRL_STANDARD:
			/* Object states: */ 
			for(i=0;i<editor->ov_selected->n_states;i++) {
				sprintf(tmp2,"STATE %.2i:",i);
				print_left(tmp2,font,255,255,255,sfc,4-stx,start_y-sty);

				print_left(editor->ov_selected->g_state_description[i],font,128,128,255,sfc,64-stx,start_y-sty);

				start_y+=10;
				print_left("          ANIM:",font,255,255,255,sfc,4-stx,start_y-sty);
				for(j=0;j<editor->ov_selected->nparts;j++) {
					/* Draw the box behind the anim: */ 
					{
						SDL_Rect r;

						r.x=(140-stx)+j*100;
						r.y=(start_y-sty) - 1;
						r.w=100;
						r.h=TTF_FontHeight(font)+2;
						if ((j&0x01)==0) SDL_FillRect(sfc,&r,0x00000020);
									else SDL_FillRect(sfc,&r,0x00000040);
					}
					tmp=editor->ov_selected->g_state_anim[j][i]->generate_string();
					if (strlen(tmp)>12) {
						tmp[11]='.';
						tmp[12]='.';
						tmp[13]='.';
						tmp[14]=0;
					} /* if */ 
					print_left(tmp,font,255,255,255,sfc,150+j*100-stx,start_y-sty);
					delete []tmp;

				} /* for */ 

				start_y+=10;
				print_left("          ACTION:",font,255,255,255,sfc,4-stx,start_y-sty);

				tmp=editor->ov_selected->g_state_action[i]->generate_string();
				print_left(tmp,font,255,255,255,sfc,144-stx,start_y-sty);
				delete []tmp;
				start_y+=10;	
			} /* for */ 
			start_y+=10;
			break;

		case CTRL_TEXT:
		case CTRL_GAMEWINDOW:
		case CTRL_MENU:
			/* Object states: */ 
			for(i=0;i<editor->ov_selected->n_states;i++) {
				sprintf(tmp2,"STATE %.2i:",i);
				print_left(tmp2,font,255,255,255,sfc,4-stx,start_y-sty);

				print_left(editor->ov_selected->g_state_description[i],font,128,128,255,sfc,64-stx,start_y-sty);

				start_y+=10;
				print_left("          ACTION:",font,255,255,255,sfc,4-stx,start_y-sty);

				tmp=editor->ov_selected->g_state_action[i]->generate_string();
				print_left(tmp,font,255,255,255,sfc,144-stx,start_y-sty);
				delete []tmp;
				start_y+=10;	
			} /* for */ 
			start_y+=10;
			break;
		} /* switch */ 

		/* Special states: */ 
		switch(editor->ov_selected->control) {
		case CTRL_CHARACTER:
		case CTRL_STANDARD:
			for(i=0;i<editor->ov_selected->n_s_states;i++) {
				sprintf(tmp2,"STATE %.2i:",i);
				print_left(tmp2,font,255,255,255,sfc,4-stx,start_y-sty);

				print_left(editor->ov_selected->g_s_state_description[i],font,128,128,255,sfc,64-stx,start_y-sty);

				start_y+=10;
				print_left("         CONDITION:",font,255,255,255,sfc,4-stx,start_y-sty);
				tmp=editor->ov_selected->g_s_state_condition[i]->generate_string();
				print_left(tmp,font,255,255,255,sfc,140-stx,start_y-sty);
				delete []tmp;
				start_y+=10;

				sprintf(tmp2,"         ANIM:");
				print_left(tmp2,font,255,255,255,sfc,4-stx,start_y-sty);

				for(j=0;j<editor->ov_selected->nparts;j++) {
					/* Draw the box behind the anim: */ 
					{
						SDL_Rect r;

						r.x=(140-stx)+j*100;
						r.y=(start_y-sty) - 1;
						r.w=100;
						r.h=TTF_FontHeight(font)+2;
						if ((j&0x01)==0) SDL_FillRect(sfc,&r,0x00000020);
									else SDL_FillRect(sfc,&r,0x00000040);
					}
					tmp=editor->ov_selected->g_s_state_anim[j][i]->generate_string();
					if (strlen(tmp)>12) {
						tmp[11]='.';
						tmp[12]='.';
						tmp[13]='.';
						tmp[14]=0;
					} /* if */ 
					print_left(tmp,font,255,255,255,sfc,150+j*100-stx,start_y-sty);
					delete []tmp;
				} /* for */ 

				start_y+=10;

				print_left("         ACTION:",font,255,255,255,sfc,4-stx,start_y-sty);
				tmp=editor->ov_selected->g_s_state_action[i]->generate_string();
				print_left(tmp,font,255,255,255,sfc,140-stx,start_y-sty);
				delete []tmp;
				start_y+=10;	

				print_left("         EXCLUSIVE:",font,255,255,255,sfc,4-stx,start_y-sty);
				if (editor->ov_selected->g_s_state_exclusiveness[i]) print_left("YES",font,255,255,255,sfc,140-stx,start_y-sty);
																else print_left("NO",font,255,255,255,sfc,140-stx,start_y-sty);

				sprintf(tmp2,"PRIORITY: %i",editor->ov_selected->g_s_state_priority[i]);
				print_left(tmp2,font,255,255,255,sfc,200-stx,start_y-sty);

				start_y+=20;	
			} /* for */ 
			break;

		case CTRL_TEXT:
		case CTRL_GAMEWINDOW:
			for(i=0;i<editor->ov_selected->n_s_states;i++) {
				sprintf(tmp2,"STATE %.2i:",i);
				print_left(tmp2,font,255,255,255,sfc,4-stx,start_y-sty);

				print_left(editor->ov_selected->g_s_state_description[i],font,128,128,255,sfc,64-stx,start_y-sty);

				start_y+=10;
				print_left("         CONDITION:",font,255,255,255,sfc,4-stx,start_y-sty);
				tmp=editor->ov_selected->g_s_state_condition[i]->generate_string();
				print_left(tmp,font,255,255,255,sfc,140-stx,start_y-sty);
				delete []tmp;
				start_y+=10;

				print_left("         ACTION:",font,255,255,255,sfc,4-stx,start_y-sty);
				tmp=editor->ov_selected->g_s_state_action[i]->generate_string();
				print_left(tmp,font,255,255,255,sfc,140-stx,start_y-sty);
				delete []tmp;
				start_y+=10;	

				print_left("         EXCLUSIVE:",font,255,255,255,sfc,4-stx,start_y-sty);
				if (editor->ov_selected->g_s_state_exclusiveness[i]) print_left("YES",font,255,255,255,sfc,140-stx,start_y-sty);
																else print_left("NO",font,255,255,255,sfc,140-stx,start_y-sty);

				sprintf(tmp2,"PRIORITY: %i",editor->ov_selected->g_s_state_priority[i]);
				print_left(tmp2,font,255,255,255,sfc,200-stx,start_y-sty);

				start_y+=20;	
			} /* for */ 
			break;
		} /* switch */ 

	} /* if */ 

} /* OPropertiesWnd::draw_contens */ 


bool OPropertiesWnd::button_pressed(int ID)
{
	switch(ID) {
	case 1:
		/* CHANGE CONSTITUTION: */ 
		if (editor->ov_selected!=0) {
			switch(editor->ov_selected->constitution) {
			case CONS_NONE:
				editor->ov_selected->constitution=CONS_SOLID;
				break;
			case CONS_SOLID:
				editor->ov_selected->constitution=CONS_SOLID_SURFACE;
				break;
			case CONS_SOLID_SURFACE:
				editor->ov_selected->constitution=CONS_WEAPON;
				break;
			case CONS_WEAPON:
				editor->ov_selected->constitution=CONS_LADDER;
				break;
			case CONS_LADDER:
				editor->ov_selected->constitution=CONS_CHARACTER;
				break;
			case CONS_CHARACTER:
				editor->ov_selected->constitution=CONS_ITEM;
				break;
			default:
				editor->ov_selected->constitution=CONS_NONE;
				break;
			} /* switch */ 
		} /* if */ 
		set_dirty();
		break;

	case 10:
		/* CHANGE CONTROL: */ 
		if (editor->ov_selected!=0) {
			switch(editor->ov_selected->control) {
			case CTRL_STANDARD:
				editor->ov_selected->control=CTRL_TEXT;
				break;
			case CTRL_TEXT:
				editor->ov_selected->control=CTRL_GAMEWINDOW;
				break;
			case CTRL_GAMEWINDOW:
				editor->ov_selected->control=CTRL_CHARACTER;
				break;
			case CTRL_CHARACTER:
				editor->ov_selected->control=CTRL_MENU;
				break;
			default:
				editor->ov_selected->control=CTRL_STANDARD;
				break;
			} /* switch */ 
		} /* if */ 
		set_dirty();
		break;

	case 2:
		{
			int j;

			/* ADD A SPECIAL STATE: */ 
			if (editor->ov_selected->n_s_states==0) {
				editor->ov_selected->n_s_states=1;
				for(j=0;j<MAX_PARTS;j++) editor->ov_selected->g_s_state_anim[j]=new AnimSCRIPT *[1];
				for(j=0;j<MAX_PARTS;j++) editor->ov_selected->g_s_state_anim[j][0]=new AnimSCRIPT();
				editor->ov_selected->g_s_state_action=new ActionSCRIPT *[1];
				editor->ov_selected->g_s_state_action[0]=new ActionSCRIPT();
				editor->ov_selected->g_s_state_condition=new ConditionSCRIPT *[1];
				editor->ov_selected->g_s_state_condition[0]=new ConditionSCRIPT();
				editor->ov_selected->g_s_state_exclusiveness=new bool[1];
				editor->ov_selected->g_s_state_exclusiveness[0]=false;
				editor->ov_selected->g_s_state_priority=new int[1];
				editor->ov_selected->g_s_state_priority[0]=0;
				editor->ov_selected->g_s_state_description=new char *[1];
				editor->ov_selected->g_s_state_description[0]=new char[1];
				editor->ov_selected->g_s_state_description[0][0]=0;

			} else {
				int i;
				AnimSCRIPT **tmp[MAX_PARTS];
				ActionSCRIPT **tmp2;
				ConditionSCRIPT **tmp3;
				bool *tmp4;
				int *tmp5;
				char **tmp6;
	
				for(j=0;j<MAX_PARTS;j++) tmp[j]=new AnimSCRIPT *[editor->ov_selected->n_s_states+1];
				tmp2=new ActionSCRIPT *[editor->ov_selected->n_s_states+1];
				tmp3=new ConditionSCRIPT *[editor->ov_selected->n_s_states+1];
				tmp4=new bool[editor->ov_selected->n_s_states+1];
				tmp5=new int[editor->ov_selected->n_s_states+1];
				tmp6=new char *[editor->ov_selected->n_s_states+1];
				for(i=0;i<editor->ov_selected->n_s_states;i++) {
					for(j=0;j<MAX_PARTS;j++) tmp[j][i]=editor->ov_selected->g_s_state_anim[j][i];
					for(j=0;j<MAX_PARTS;j++) editor->ov_selected->g_s_state_anim[j][i]=0;
					tmp2[i]=editor->ov_selected->g_s_state_action[i];
					editor->ov_selected->g_s_state_action[i]=0;
					tmp3[i]=editor->ov_selected->g_s_state_condition[i];
					editor->ov_selected->g_s_state_condition[i]=0;
					tmp4[i]=editor->ov_selected->g_s_state_exclusiveness[i];
					tmp5[i]=editor->ov_selected->g_s_state_priority[i];
					tmp6[i]=editor->ov_selected->g_s_state_description[i];
					editor->ov_selected->g_s_state_description[i]=0;
				} /* for */ 
				for(j=0;j<MAX_PARTS;j++) tmp[j][editor->ov_selected->n_s_states]=new AnimSCRIPT();
				tmp2[editor->ov_selected->n_s_states]=new ActionSCRIPT();
				tmp3[editor->ov_selected->n_s_states]=new ConditionSCRIPT();
				tmp4[editor->ov_selected->n_s_states]=false;
				tmp5[editor->ov_selected->n_s_states]=0;
				tmp6[editor->ov_selected->n_s_states]=new char[1];
				tmp6[editor->ov_selected->n_s_states][0]=0;
				editor->ov_selected->n_s_states++;
				for(j=0;j<MAX_PARTS;j++) delete []editor->ov_selected->g_s_state_anim[j];
				for(j=0;j<MAX_PARTS;j++) editor->ov_selected->g_s_state_anim[j]=tmp[j];
				delete []editor->ov_selected->g_s_state_action;
				editor->ov_selected->g_s_state_action=tmp2;
				delete []editor->ov_selected->g_s_state_condition;
				editor->ov_selected->g_s_state_condition=tmp3;
				delete []editor->ov_selected->g_s_state_exclusiveness;
				editor->ov_selected->g_s_state_exclusiveness=tmp4;
				delete []editor->ov_selected->g_s_state_priority;
				editor->ov_selected->g_s_state_priority=tmp5;
				delete []editor->ov_selected->g_s_state_description;
				editor->ov_selected->g_s_state_description=tmp6;
			} /* if */ 
			set_dirty();
		}
		break;

	case 3:
		{
			int j;

			/* SUB A SPECIAL STATE: */ 
			if (editor->ov_selected->n_s_states<=1) {
				if (editor->ov_selected->n_s_states==1) {
					for(j=0;j<MAX_PARTS;j++) delete []editor->ov_selected->g_s_state_anim[j];
					for(j=0;j<MAX_PARTS;j++) editor->ov_selected->g_s_state_anim[j]=0;
					delete []editor->ov_selected->g_s_state_action;
					editor->ov_selected->g_s_state_action=0;
					delete []editor->ov_selected->g_s_state_condition;
					editor->ov_selected->g_s_state_condition=0;
					delete []editor->ov_selected->g_s_state_exclusiveness;
					editor->ov_selected->g_s_state_exclusiveness=0;
					delete []editor->ov_selected->g_s_state_priority;
					editor->ov_selected->g_s_state_priority=0;
					delete []editor->ov_selected->g_s_state_description[0];
					editor->ov_selected->g_s_state_description[0]=0;
					delete []editor->ov_selected->g_s_state_description;
					editor->ov_selected->g_s_state_description=0;
					editor->ov_selected->n_s_states=0;
				} /* if */ 
			} else {
				int i;
				AnimSCRIPT **tmp[MAX_PARTS];
				ActionSCRIPT **tmp2;
				ConditionSCRIPT **tmp3;
				bool *tmp4;
				int *tmp5;
				char **tmp6;
	
				for(j=0;j<MAX_PARTS;j++) tmp[j]=new AnimSCRIPT *[editor->ov_selected->n_s_states-1];
				tmp2=new ActionSCRIPT *[editor->ov_selected->n_s_states-1];
				tmp3=new ConditionSCRIPT *[editor->ov_selected->n_s_states-1];
				tmp4=new bool[editor->ov_selected->n_s_states-1];
				tmp5=new int[editor->ov_selected->n_s_states-1];
				tmp6=new char *[editor->ov_selected->n_s_states-1];
				for(i=0;i<editor->ov_selected->n_s_states-1;i++) {
					for(j=0;j<MAX_PARTS;j++) tmp[j][i]=editor->ov_selected->g_s_state_anim[j][i];
					for(j=0;j<MAX_PARTS;j++) editor->ov_selected->g_s_state_anim[j][i]=0;
					tmp2[i]=editor->ov_selected->g_s_state_action[i];
					editor->ov_selected->g_s_state_action[i]=0;
					tmp3[i]=editor->ov_selected->g_s_state_condition[i];
					editor->ov_selected->g_s_state_condition[i]=0;
					tmp4[i]=editor->ov_selected->g_s_state_exclusiveness[i];
					tmp5[i]=editor->ov_selected->g_s_state_priority[i];
					tmp6[i]=editor->ov_selected->g_s_state_description[i];
				} /* for */ 
				for(j=0;j<MAX_PARTS;j++) delete editor->ov_selected->g_s_state_anim[j][editor->ov_selected->n_s_states-1];
				editor->ov_selected->g_s_state_anim[editor->ov_selected->n_s_states-1]=0;
				delete editor->ov_selected->g_s_state_action[editor->ov_selected->n_s_states-1];
				editor->ov_selected->g_s_state_action[editor->ov_selected->n_s_states-1]=0;
				delete editor->ov_selected->g_s_state_condition[editor->ov_selected->n_s_states-1];
				editor->ov_selected->g_s_state_anim[editor->ov_selected->n_s_states-1]=0;
				delete []editor->ov_selected->g_s_state_description[editor->ov_selected->n_s_states-1];
				editor->ov_selected->g_s_state_description[editor->ov_selected->n_s_states-1]=0;
				editor->ov_selected->n_s_states--;
				for(j=0;j<MAX_PARTS;j++) delete []editor->ov_selected->g_s_state_anim[j];
				for(j=0;j<MAX_PARTS;j++) editor->ov_selected->g_s_state_anim[j]=tmp[j];
				delete []editor->ov_selected->g_s_state_action;
				editor->ov_selected->g_s_state_action=tmp2;
				delete []editor->ov_selected->g_s_state_condition;
				editor->ov_selected->g_s_state_condition=tmp3;
				delete []editor->ov_selected->g_s_state_exclusiveness;
				editor->ov_selected->g_s_state_exclusiveness=tmp4;
				delete []editor->ov_selected->g_s_state_priority;
				editor->ov_selected->g_s_state_priority=tmp5;
				delete []editor->ov_selected->g_s_state_description;
				editor->ov_selected->g_s_state_description=tmp6;
			} /* if */ 
			set_dirty();
		}
		break;

	case 4:
		{
			BOVariableEditorWnd *dlg=new BOVariableEditorWnd(100,50,200,300,editor,font);

			dlg->Execute();
			delete dlg;

			set_dirty();
		}
		break;

	case 7:
		{
			int j;

			/* ADD A STATE: */ 
			if (editor->ov_selected->n_states==0) {
				editor->ov_selected->n_states=1;
				for(j=0;j<MAX_PARTS;j++) editor->ov_selected->g_state_anim[j]=new AnimSCRIPT *[1];
				for(j=0;j<MAX_PARTS;j++) editor->ov_selected->g_state_anim[j][0]=new AnimSCRIPT();
				editor->ov_selected->g_state_action=new ActionSCRIPT *[1];
				editor->ov_selected->g_state_action[0]=new ActionSCRIPT();
				editor->ov_selected->g_state_description=new char *[1];
				editor->ov_selected->g_state_description[0]=new char[1];
				editor->ov_selected->g_state_description[0][0]=0;

			} else {
				int i;
				AnimSCRIPT **tmp[MAX_PARTS];
				ActionSCRIPT **tmp2;
				char **tmp3;
	
				for(j=0;j<MAX_PARTS;j++) tmp[j]=new AnimSCRIPT *[editor->ov_selected->n_states+1];
				tmp2=new ActionSCRIPT *[editor->ov_selected->n_states+1];
				tmp3=new char *[editor->ov_selected->n_states+1];
				for(i=0;i<editor->ov_selected->n_states;i++) {
					for(j=0;j<MAX_PARTS;j++) tmp[j][i]=editor->ov_selected->g_state_anim[j][i];
					for(j=0;j<MAX_PARTS;j++) editor->ov_selected->g_state_anim[j][i]=0;
					tmp2[i]=editor->ov_selected->g_state_action[i];
					editor->ov_selected->g_state_action[i]=0;
					tmp3[i]=editor->ov_selected->g_state_description[i];
					editor->ov_selected->g_state_description[i]=0;
				} /* for */ 
				for(j=0;j<MAX_PARTS;j++) tmp[j][editor->ov_selected->n_states]=new AnimSCRIPT();
				tmp2[editor->ov_selected->n_states]=new ActionSCRIPT();
				tmp3[editor->ov_selected->n_states]=new char[1];
				tmp3[editor->ov_selected->n_states][0]=0;
				editor->ov_selected->n_states++;
				for(j=0;j<MAX_PARTS;j++) delete []editor->ov_selected->g_state_anim[j];
				for(j=0;j<MAX_PARTS;j++) editor->ov_selected->g_state_anim[j]=tmp[j];
				delete []editor->ov_selected->g_state_action;
				delete []editor->ov_selected->g_state_description;
				editor->ov_selected->g_state_action=tmp2;
				editor->ov_selected->g_state_description=tmp3;
			} /* if */ 
			set_dirty();
		}
		break;

	case 8:
		{
			int j;

			/* SUB A STATE: */ 
			if (editor->ov_selected->n_states<=1) {
				if (editor->ov_selected->n_states==1) {
					for(j=0;j<MAX_PARTS;j++) delete []editor->ov_selected->g_state_anim[j];
					for(j=0;j<MAX_PARTS;j++) editor->ov_selected->g_state_anim[j]=0;
					delete []editor->ov_selected->g_state_action;
					editor->ov_selected->g_state_action=0;
					delete []editor->ov_selected->g_state_description[0];
					editor->ov_selected->g_state_description[0]=0;
					delete []editor->ov_selected->g_state_description;
					editor->ov_selected->g_state_description=0;
					editor->ov_selected->n_states=0;
				} /* if */ 
			} else {
				int i;
				AnimSCRIPT **tmp[MAX_PARTS];
				ActionSCRIPT **tmp2;
				char **tmp3;
	
				for(j=0;j<MAX_PARTS;j++) tmp[j]=new AnimSCRIPT *[editor->ov_selected->n_states-1];
				tmp2=new ActionSCRIPT *[editor->ov_selected->n_states-1];
				tmp3=new char *[editor->ov_selected->n_states-1];
				for(i=0;i<editor->ov_selected->n_states-1;i++) {
					for(j=0;j<MAX_PARTS;j++) tmp[j][i]=editor->ov_selected->g_state_anim[j][i];
					for(j=0;j<MAX_PARTS;j++) editor->ov_selected->g_state_anim[j][i]=0;
					tmp2[i]=editor->ov_selected->g_state_action[i];
					editor->ov_selected->g_state_action[i]=0;
					tmp3[i]=editor->ov_selected->g_state_description[i];
					editor->ov_selected->g_state_description[i]=0;
				} /* for */ 
				for(j=0;j<MAX_PARTS;j++) {
					delete editor->ov_selected->g_state_anim[j][editor->ov_selected->n_states-1];
					editor->ov_selected->g_state_anim[j][editor->ov_selected->n_states-1]=0;
				} /* for */ 
				delete editor->ov_selected->g_state_action[editor->ov_selected->n_states-1];
				editor->ov_selected->g_state_action[editor->ov_selected->n_states-1]=0;
//				editor->ov_selected->g_state_anim[editor->ov_selected->n_states-1]=0;
				delete []editor->ov_selected->g_state_description[editor->ov_selected->n_states-1];
				editor->ov_selected->g_state_description[editor->ov_selected->n_states-1]=0;
				editor->ov_selected->n_states--;
				for(j=0;j<MAX_PARTS;j++) delete []editor->ov_selected->g_state_anim[j];
				for(j=0;j<MAX_PARTS;j++) editor->ov_selected->g_state_anim[j]=tmp[j];
				delete []editor->ov_selected->g_state_action;
				editor->ov_selected->g_state_action=tmp2;
				delete []editor->ov_selected->g_state_description;
				editor->ov_selected->g_state_description=tmp3;
			} /* if */ 
			set_dirty();
		}
		break;
                
        case 9: 
                {
			BDrawingModeWnd *dlg=new BDrawingModeWnd(100,50,200,200,editor->ov_selected,font);

			dlg->Execute();
			delete dlg;

			set_dirty();
		}                
                break;

	default:
		break;
	} /* switch */ 

	return true;
} /* OPropertiesWnd::button_pressed */ 
